unit FMainGetIcons;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdHTTP,
  StdCtrls, ExtCtrls, ComCtrls, pngimage, jpeg, Spin, Contnrs, Menus, ImgList;

type

  {: Clase para descargar una imagen y almacenarla en disco.}
  TDownImageThread = class(TThread)
  private
    FURLImage: string;
    FPathImage: string;
    FFileNameImage: string;
    // Internas
    ImageName: string;
    PathURL: string;
    // Componente
    idH:TidHTTP;
    IdSSL:TIdSSLIOHandlerSocket;
  public
    // redefinir mtodos
    constructor  Create(AURL:string; AOutPathImages:string);
    destructor Destroy; override;
    procedure Execute; override;
    {: URL de la imagen a descargar. }
    property URLImage:string read FURLImage write FURLImage;
    {: Path de disco local donde voy a almacenar la imagen.}
    property PathImage:string read FPathImage;
    {: Nombre completa (path+Nombre) de la imagen almacenada en disco local}
    property FileNameImage:string read FFileNameImage;
  end;

  TFormMain = class(TForm)
    LBLtOTAL: TLabel;
    Panel1: TPanel;
    Label1: TLabel;
    edtURL: TEdit;
    Panel2: TPanel;
    pbLinks: TProgressBar;
    pbTotal: TProgressBar;
    lblPaso1: TLabel;
    lblPaso2: TLabel;
    lblPaso3: TLabel;
    Label2: TLabel;
    seNumThreads: TSpinEdit;
    Label3: TLabel;
    edtThreadsActivos: TEdit;
    Panel3: TPanel;
    btnCerrar: TButton;
    StatusBar1: TStatusBar;
    PageControl1: TPageControl;
    tabsContent: TTabSheet;
    TabLinks: TTabSheet;
    tsImagenes: TTabSheet;
    mmContent: TMemo;
    mmLinks: TMemo;
    btnDetener: TButton;
    ScrollBox1: TScrollBox;
    pmImagen: TPopupMenu;
    inombre: TMenuItem;
    iPath: TMenuItem;
    iheight: TMenuItem;
    iWidth: TMenuItem;
    N1: TMenuItem;
    iGrabar: TMenuItem;
    iAbrir: TMenuItem;
    Explorarendisco1: TMenuItem;
    ImageList1: TImageList;
    Button1: TButton;
    Panel4: TPanel;
    edtBusqueda: TEdit;
    Button2: TButton;
    CheckBox1: TCheckBox;
    //procedure Button1Click(Sender: TObject);
    procedure lblPaso1Click(Sender: TObject);
    procedure lblPaso2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure lblPaso3Click(Sender: TObject);
    procedure btnCerrarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure StatusBar1Click(Sender: TObject);
    procedure pmImagenPopup(Sender: TObject);
    procedure btnDetenerClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure iAbrirClick(Sender: TObject);
    procedure Explorarendisco1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    ThreadCount:integer;
    TSContent, TSLinks, DownLoaded:TStrings;
    pathImages:string;
    imList:TObjectList;
    flagStop:Boolean;
    gSearch:Boolean;

    LastX, LastY:integer;
    TotalWidth:integer;

    procedure ViewImage(Sender: TObject);
    procedure Recolocar(AImage:TImage);
    procedure CreateImage(APath:string);
    procedure TerminateThread(Sender: TObject);
    procedure ActiveLabel(lbl:TLabel; Desactivar:Boolean=False);

  public
    { Public declarations }
  end;

  TRGB = array[1..3] of Byte;

const
  STR_EMPTY = '';
  DIR_IMAGENES = 'imgs';
  MAX_TIMAGE_SIZE = 220;

var
  FormMain: TFormMain;


implementation

{$R *.dfm}

uses
  ShellAPI, FileCtrl, Math,
  IdSSLOpenSSL,
  IdIOHandler, IdIOHandlerSocket,

  StrUtils, MSHTML, idURI, ActiveX, comObj, FViewImage;


procedure TFormMain.ActiveLabel(lbl: TLabel; Desactivar:Boolean=False);
begin
  if (Desactivar) then begin
    lbl.Cursor := crDefault;
    lbl.Font.Color := clDefault;
    lbl.Font.Style := lbl.Font.Style - [fsUnderline];
  end
  else begin
    lbl.Cursor := crHandPoint;
    lbl.Font.Color := clBlue;
    lbl.Font.Style := lbl.Font.Style + [fsUnderline];
  end;
end;

procedure TFormMain.btnCerrarClick(Sender: TObject);
var
  b,i:integer;
begin
  btnDetener.Click;

  // Borrar todos los ficgheros descargados?
  b := MessageBox(0, 'Desea borrar todos los ficheros de imagen creados durante al ejecucin del programa?',
                  'Borrar ficheros temporales', MB_ICONQUESTION or MB_YESNO or MB_DEFBUTTON1);
  if (b = IDYES) then begin
    // recorrer los ficheros
    for i := 0 to (DownLoaded.Count - 1) do begin
      try
        DeleteFile(DownLoaded[i]);
        RemoveDir(ExtractFileDir(DownLoaded[i]))
      except
        // Nada...
      end;
    end;
  end;
  // cerrar
  Self.Close;
end;


procedure TFormMain.btnDetenerClick(Sender: TObject);
begin
  flagStop := True;
end;


procedure TFormMain.Button1Click(Sender: TObject);
begin
  // Liberarla
  imList.Free;
  // Crearla de nuevo
  imList := TObjectList.Create;
  imList.OwnsObjects := True;

end;

procedure TFormMain.Button2Click(Sender: TObject);
begin

  edtURL.Text := 'http://www.google.es/images?q=' + AnsiReplaceText(edtBusqueda.Text, ' ', '+') +
                '&biw=1264&bih=859';
  gSearch := True;


end;

procedure TFormMain.Recolocar(AImage: TImage);
begin

  // Ancho de lasimagenes de la linea
  TotalWidth := TotalWidth + AImage.Width;
  // sobrepasa el ancho
  if ((TotalWidth + 10 + 30 {Scroll}) >= tsImagenes.Width) then begin
    TotalWidth := 0;
    LastX := 0;
    LastY := LastY + AImage.Height + 5{SPACE};
  end;

  // posicionarlo
  AImage.Left := LastX;
  AImage.Top := LastY;
  // Incrementar las posiciones
  LastX := LastX + AImage.Width;
end;

// Crear un TImage para la imagen...
procedure TFormMain.CreateImage(APath: string);
var
  im:TImage;
begin
                                                             
  // Crear el TImage y aadirlo a la lista
  im := TImage.Create(nil);
  // proteccion para generar el PNG (algunas imgenes dan error)
  // Tal vez habra que usar version ms moderna del componente
  try
    im.Parent := ScrollBox1;
    // Cargar la imagen
    im.Picture.LoadFromFile(APath);
    im.Proportional := True;
    // Tamao
    im.Height := Min(im.Picture.Height, MAX_TIMAGE_SIZE);
    im.Width := Min(im.Picture.Width, MAX_TIMAGE_SIZE);
    // menu
    im.PopupMenu := pmImagen;
    im.Hint := APath;
    // Aadirlo a lalista
    imList.Add(im);

    // Evento OnClick
    im.OnClick := ViewImage;

    // posicion
    Recolocar(im);
  except
		// erroeres al generar algunas imgenes.
    //...
    // No es el final de este ejemplo...
  end;

end;

procedure TFormMain.Explorarendisco1Click(Sender: TObject);
begin
    // Abrir
    ShellExecute(Handle,
         'open',
         PChar(IncludeTrailingBackslash(iPath.Caption)),
         nil,
         nil,
         SW_SHOW);


end;


procedure TFormMain.FormCreate(Sender: TObject);
begin

  // ini
  TSContent := TStringList.Create;
  TSLinks := TStringList.Create;
  DownLoaded := TStringList.Create;

end;


procedure TFormMain.FormDestroy(Sender: TObject);
begin
  FreeAndNil(TSContent);
  FreeAndNil(TSLinks);
  FreeAndNil(imList);
  FreeAndNil(DownLoaded);
end;

procedure TFormMain.FormResize(Sender: TObject);
var
  i:Integer;
  im:TImage;
begin

  // Hay algo a recolocar?
  if (imList.Count = 0) then begin
    Exit;
  end;

  // posicionado
  LastX := 0;
  LastY := 0;
  TotalWidth := 0;
  // Lock Form
  Self.Constraints.MinWidth := Width;
  Self.Constraints.MaxWidth := Width;
  // proteccion
  try

    // Recolocar todas las imagenes
    for i := 0 to (imList.Count - 1) do begin
      if (imList.Items[i] is TImage) then begin
        im := TImage(imList.Items[i]);
        Recolocar(im);
      end;
    end;
  finally
    // Lock Form
    Self.Constraints.MinWidth := 0;
    Self.Constraints.MaxWidth := 0;
  end;

end;

procedure TFormMain.FormShow(Sender: TObject);
begin
  PageControl1.ActivePageIndex := 0;
  // ini
  imList := TObjectList.Create;
  imList.OwnsObjects := True;

end;

procedure TFormMain.iAbrirClick(Sender: TObject);
begin
    // Abrir
    ShellExecute(Handle,
         'open',
         PChar(IncludeTrailingBackslash(iPath.Caption) + iNombre.Caption),
         nil,
         nil,
         SW_SHOW);

end;

procedure TFormMain.lblPaso1Click(Sender: TObject);
var
  StrURL:string;
  IdH:TIdHTTP;
  Resp:String;
begin
  // ini
  TSContent.Clear;
  btnDetener.Enabled := False;
  ActiveLabel(lblPaso2, True);
  ActiveLabel(lblPaso3, True);
  PageControl1.ActivePage := tabsContent;
  // Memos
  TSContent.Clear;
  mmContent.Clear;
  mmLinks.Clear;
  TSLinks.Clear;
  Application.ProcessMessages;
  // URL de la pgina
  StrURL := edtURL.Text; {'https://sites.google.com/site/gmapsdevelopment/Home'};
  // Crear componente para acceder
  IdH := TidHttp.Create(nil);
  IdH.ReadTimeout := 30000;
  IdSSL := TIdSSLIOHandlerSocket.Create(nil);
  IdH.IOHandler := IdSSL;
  IdSSL.SSLOptions.Method := sslvTLSv1;
  IdSSL.SSLOptions.Mode := sslmUnassigned;

  // proteccion para liberar
  try
    // proteccion por error
    try
      // Obtenemos la pagina
      Resp := IdH.Get(Trim(StrURL));
      // recuperamos la respuesta
      TSContent.Text  := Resp;
      mmContent.Lines.Text := Resp;
      // Activar el siguiente paso
      ActiveLabel(lblPaso2);
    except
      on E:Exception do begin
        MessageDlg('Error al acceder a la pgina. '+#13+#10+'Mensaje: '+E.Message, mtError, [mbOK], 0);
      end;
    end;  // try
  finally
    IdH.Free;
    IdSSL.Free;
  end;

end;

procedure TFormMain.lblPaso2Click(Sender: TObject);
var
  i, delta:integer;
  str, tmp:string;
  p0, p1, p2:integer;
  prefix:String;
  flag:boolean;
  imgExt:string;
const
  PREFIX1 = 'src="http://';
  PREFIX2 = 'imgurl=http://';
begin

  // ini9
  TSLinks.Clear;
  flag := False;
  imgExt := '.png';

  if (gSearch) then begin
    prefix := PREFIX2;
    delta := 7;
  end
  else begin
    prefix := PREFIX1;
    delta := 5;
  end;
  gSearch := False;

  // Linea
  Str := TSContent.Text;

  // progress
//  pbLinks.Min := 0;
//  pbLinks.Max := TSContent.Count;

  // recorrer las lineas de la pgina
  while not flag do begin
    // contiene un Link a imagen
    if (AnsiPos(prefix, Str) <> 0) and
       (AnsiPos(imgExt, Str) <> 0) then begin
      // Buscar link en la lnea  (Imagen PNG)
      p1 := AnsiPos(prefix, Str);
      Str := Copy(Str, p1+delta, Length(Str));
      p1 := 1;
      p0 := AnsiPos(prefix, Str);
      p2 := AnsiPos(imgExt, Str);

      if (p0 > p2) or (p0 = 0) then begin
        tmp := Copy(Str, p1, (p2-p1+4));
        Str := Copy(Str, p2, Length(Str));

        // version pra https
        tmp := Trim(tmp);
        tmp := AnsiReplaceText(tmp, 'http://', 'https://');
        
        // Aadirlo
        TSLinks.Add(Trim(tmp));
      end
      else begin
        Str := Copy(Str, p2, Length(Str));
      end;
    end
    else begin
      // Acabado
      flag := True;
    end;
    // progressbar
//    pbLinks.Position := i;
    Application.ProcessMessages;
  end;

  // Hay alguna?
  if (TSLinks.Count > 0) then begin
		mmLinks.Lines.AddStrings(TSLinks);
    ActiveLabel(lblPaso3);
    PageControl1.ActivePage := TabLinks;
  end;
end;

procedure TFormMain.lblPaso3Click(Sender: TObject);
var
  i:integer;
  th:TDownImageThread;
begin

  // Ini
  pbTotal.Min := 0;
  pbTotal.Max := ({TSLinks}mmLinks.Lines.Count - 1);
  PageControl1.ActivePage := tsImagenes;
  btnDetener.Enabled := True;
  flagStop := False;
  // posicionado
  LastX := 0;
  LastY := 0;
  TotalWidth := 0;
  // Lock Form
  Self.Constraints.MinWidth := Width;
  Self.Constraints.MaxWidth := Width;
  // proteccion
  try

    // Path de salida
    pathImages := IncludeTrailingBackslash(ExtractFilePath(Application.ExeName));
    pathImages := IncludeTrailingBackslash(pathImages + DIR_IMAGENES);

    // recorrer los links
    for i := 0 to ({TSLinks}mmLinks.Lines.Count - 1) do begin
      // Detener?
      if (flagStop) then begin
        Break;
      end;
      // Hay algo?
      if (Trim({TSLinks}mmLinks.Lines[i]) <> STR_EMPTY) then begin
        // Nmero de threads (para macar un mximo)
        Inc(ThreadCount);

        // Si nos pasamos del mximo esperamos...
        while (ThreadCount >= seNumThreads.Value) do begin
          Sleep(250);
          Application.ProcessMessages;
        end;

        // Crear un nuevo thread para descargar la imagen
        th := TDownImageThread.Create({TSLinks}mmLinks.Lines[i], pathImages);
        th.OnTerminate := TerminateThread;
        th.Resume;
        // procesar
        Application.ProcessMessages;
      end;
    end; // for
  finally
    // Lock Form
    Self.Constraints.MinWidth := 0;
    Self.Constraints.MaxWidth := 0;
  end;
end;

procedure TFormMain.pmImagenPopup(Sender: TObject);
var
  img:TImage;
begin

  // Acceso al componente
  img := TImage(TPopupMenu(Sender).PopupComponent);

  // rellenar
  inombre.Caption := ExtractFileName(img.Hint);
  iPath.Caption := ExtractFilePath(img.Hint);
  iWidth.Caption := 'Ancho: ' + IntToStr(img.Picture.Width);
  iheight.Caption := 'Alto: ' + IntToStr(img.Picture.Height);

end;

procedure TFormMain.StatusBar1Click(Sender: TObject);
begin
    ShellExecute(Handle,
         'open',
         PChar('http://neftali.clubdelphi.com'),
         nil,
         nil,
         SW_SHOW);
end;

procedure TFormMain.TerminateThread(Sender: TObject);
var
  pathImage:String;
begin

  // Imagen creada
  pathImage := TDownImageThread(Sender).FileNameImage;

  // Threads activos
  Dec(ThreadCount);
  edtThreadsActivos.Text := IntToStr(ThreadCount);
  pbTotal.Position := pbTotal.Position + 1;
  Application.ProcessMessages;

  // Crear la imagen en el form
  CreateImage(pathImage);
  DownLoaded.Add(pathImage);

end;

procedure TFormMain.ViewImage(Sender: TObject);
begin

  // Si estn en marcha los threads no esperamos...
  if (ThreadCount > 0) then exit; 

  // Visualizar la imagen
  FormViewImage := TFormViewImage.Create(Application);
  FormViewImage.ViewImage.Picture.Assign(TImage(Sender).Picture);
  FormViewImage.ShowModal;

end;

{ TDownImageThread }
constructor TDownImageThread.Create(AURL, AOutPathImages: string);
var
  URI:TidURI;
begin

  // crear el thread suspendido
  inherited Create(True);
  // Parmetros: URL y dir de salida
  Self.FURLImage := AURL;
  Self.FPathImage := AOutPathImages;
  // Procesar a URL
  URI := TidURI.Create(AURL);
  try
    ImageName := URI.Document;
    PathURL := URI.Path;
  finally
    URI.Free;
  end;
end;

destructor TDownImageThread.Destroy;
begin
  inherited;
end;

//: recupara la imagen y la guarda en disco
procedure TDownImageThread.Execute();
var
  Stream:TFileStream;
  IdH:TidHTTP;
  IdSSL:TIdSSLIOHandlerSocket;
  path:string;
  dir:string;
begin
  // Directorio de salida
  dir := AnsiReplaceText(PathURL, '/', STR_EMPTY);
  // Nombre vaco
  if (ImageName = STR_EMPTY) then begin
    Exit;
  end;
  // Path de salida
  path := IncludeTrailingBackslash(IncludeTrailingBackslash(PathImage) + dir) + ImageName;
  // Crearlo por si no existe
  ForceDirectories(ExtractFilePath(path));
  try
    // Stream para la imagfen
    Stream  := TFileStream.Create(path, fmCreate);
    try
      // Crear componente para acceder
      IdH := TidHttp.Create(nil);
      IdH.ReadTimeout := 30000;
      IdSSL := TIdSSLIOHandlerSocket.Create(nil);
      IdH.IOHandler := IdSSL;
      IdSSL.SSLOptions.Method := sslvTLSv1;
      IdSSL.SSLOptions.Mode := sslmUnassigned;
      idH.HandleRedirects := True;
      IdH.RedirectMaximum := 3;

      // proteccion
      try
        // Cambiar a https
        IdH.Get(Trim( FURLImage), Stream);
      except
        // Error al descargar la imagen
        //..  Volcarlo al log
      end;
    finally
      // Liberar
      idH.Free;
//      IdSSL.Free;
      Stream.Free;
    end;
    // Path de salida
    FFileNameImage := path;
  except
    // error al crear el fichero
    //...  Log
  end;
end;

end.
